package nl.tue.id.pp.boids;
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import processing.core.*;

/**
 *
 * @author ppeters
 * 
 * A Boid represents a shape on the screen that can rotate and point in a direction 
 */
public class Boid extends Shape {

	/** properties
	 * 
	 */
    private float theta;       // heading (degrees)

    /** boid constructor
     * 
     * @param parent parent PApplet
     * @param x x position on canvas
     * @param y x position on canvas
     * @param t initial rotation
     */
    public Boid(int x, int y, float t) {
    	super(x,y);
        theta = t;
    }

    /** set rotation of boid
     * 
     * @param a angle of rotation
     */
    public void setAngle(float a) {
        theta = (float) (a % 360.0);
    }

    /** point boid to x,y position in canvas
     * 
     * @param x x position on canvas
     * @param y y position on canvas
     */
    public void pointAt(int x, int y) {
        setAngle((float)Math.atan2(x - this.getX(), this.getY() - y));
    }

    /** get rotation angle of boid
     * 
     * @return rotation angle
     */
    public float getAngle() {
        return theta;
    }

}



