package nl.tue.id.pp.boids;

/**
 * 
 * @author ppeters
 * 
 * A SquareBoid represents a square on the screen
 */
import processing.core.PApplet;

public class SquareBoid extends Boid {

    /** properties
     * 
     */
	private PApplet parent;

	/** SquareBoid constructor
	 * 
	 * @param parent parent PApplet
	 * @param x x position on canvas
	 * @param y x position on canvas
	 * @param t initial rotation
	 */
	public SquareBoid(PApplet parent, int x, int y, float t) {
		super(x,y,t);
		this.parent = parent;
	}

	/** draw SquareBoid on canvas as defined by x,y position and rotation angle
	 * 
	 */
    public void render() {
        float r = 9.0f; // defines square size
        parent.fill(200);
        parent.stroke(255);
        parent.pushMatrix();
        parent.translate(this.getX(), this.getY());
        parent.rotate(this.getAngle());

        parent.beginShape();
        parent.vertex(-r,-r);
        parent.vertex(-r,r);
        parent.vertex(r,r);
        parent.vertex(r,-r);
        parent.endShape();
        
        parent.popMatrix();
    }
    
}
