package nl.tue.id.pp.boids;

import processing.core.PApplet;

/**
 * 
 * @author ppeters
 * 
 * A TriangleBoid represents a triangle on the screen
 */
public class TriangleBoid extends Boid {

    /** properties
     * 
     */
	private PApplet parent;

	/** TriangleBoid constructor
	 * 
	 * @param parent parent PApplet
	 * @param x x position on canvas
	 * @param y x position on canvas
	 * @param t initial rotation
	 */	
	public TriangleBoid(PApplet parent, int x, int y, float t) {
		super(x,y,t);
		this.parent = parent;
	}

	/** draw TriangleBoid on canvas as defined by x,y position and rotation angle
	 * 
	 */
	public void render() {
        float r = 2.0f;
        // Draw a triangle rotated by theta
        parent.fill(200);
        parent.stroke(255);
        
        parent.pushMatrix();
        parent.translate(this.getX(), this.getY());
        parent.rotate(this.getAngle());

        parent.beginShape(processing.core.PApplet.TRIANGLES);
        parent.vertex(0, -r * 2);
        parent.vertex(-r, r * 2);
        parent.vertex(r, r * 2);
        parent.endShape();

        parent.popMatrix();
    }

}
